
/*
 whoosh777@blueyonder.co.uk,

this file is open source, it can be used + modified by anyone,
but if modified you must put comments saying which parts were modified so 
I dont get the blame, also this topmost comment may not be removed.

Lastly if you use this you must not pass it off as your own work,

the following #defines will be of use to use the reimplemented calls as actual calls,
and the commented list of #includes are probably the required includes,

whoosh_ScalerDiv and BitMapScale_reimplemented being reimplementations of 
ScalerDiv and BitMapScale respectively,

for AROS use you must compile this file with __AROS__ defined eg:

gcc -D__AROS__ ......

or do:

#define __AROS__ some_other_inbuilt_define
#include "other.c"
#undef __AROS__
*/


/*
#define	Errmess(xyz)			fprintf( stderr , "%s" , (xyz) ) ;
#define whoosh_ScalerDiv   		ScalerDiv
#define BitMapScale_reimplemented	BitMapScale
#define SF 1
#define DF 1
*/

/*
#include <graphics/scale.h>
#include <graphics/rastport.h>
#include <exec/memory.h>
#include <proto/cybergraphics.h>
#include <proto/exec.h>
#include <proto/graphics.h>
*/
#define WHOOSH_REG 
#define uu unsigned

int whoosh_ScalerDiv( int srcwidth , int num , int denom ) ;

int SF = 1024 , DF = 1 , MULTI = 20 , LOOK = 1 ;

static void enlargement( uu char *dr , 
		uu int dw , 
		uu int sw , 
		uu char *sr ,
		uu int XQ , 
		uu int XR , 
		uu int xsf , 
		uu int xdf , 
		int cyberfactor ) ;
void enlargement_look( 
		uu char *dr , 
		uu int 	 sw , 
		uu char *sr ,
		int 	 cyberfactor ,
		uu int  *look 
			) ;
void reduction_look( 
		uu char *dr , 
		WHOOSH_REG uu int   dw , 
		uu char *sr , 
		int      cyberfactor ,
		WHOOSH_REG uu int *look ) ;

static void reduction( 
		uu char *dr , 
		uu int   dw , 
		uu char *sr , 
		uu int   xq , 
		uu int   xr , 
		uu int   xsf ,
		uu int   xdf , 
		int      cyberfactor ) ;

static void reduction_sums( 
		uu char *dr , 
		uu int   dw , 
		uu int *sums,
	        uu int xs,
		uu int y,
		uu int y_new,
		uu int rwidth,
		uu int   xq , 
		uu int   xr , 
		uu int   xdf 
		) ;

static void sums_compute( uu int *sums, uu char *rarray, uu int rwidth, uu int rheight ) ;

static int rescale_realloc_line( uu char **pr , uu int *pr_size , uu int wanted_size ) ;

void MyBitMapScale_whoosh(struct BitScaleArgs * bsa , struct RastPort *srp , 
	struct RastPort *drp ,	int dest_cyberfactor , int dest_cyberformat ,
	int sf , int df , void **bsa_resources , int multi , int looker, int rwidth,
	int rheight, uu char *rarray, unsigned int *sums, char *psums_valid ) ;

void BitMapScale_reimplemented( struct BitScaleArgs *bsa ) ;


static void local_Errmess( int verbose , const char *mess ) ;

void BitMapScale_reimplemented( struct BitScaleArgs *bsa )
{
/* deals with all cases: */
int dfactor = 4 , dformat = RECTFMT_RGBA ;

/* generalised resource managed externally: */
void *bsa_resources = 0 ;

#ifdef __AROS__

struct RastPort *srp = CreateRastPort() ;
struct RastPort *drp = CreateRastPort() ;
if( srp==0 || drp==0 )goto cleanup ;

#else

struct RastPort *srp = AllocVec( sizeof( struct RastPort ), MEMF_PUBLIC | MEMF_CLEAR ) ;
struct RastPort *drp = AllocVec( sizeof( struct RastPort ), MEMF_PUBLIC | MEMF_CLEAR ) ;
if( srp==0 || drp==0 )goto cleanup ;
InitRastPort( srp ) ;
InitRastPort( drp ) ;

#endif

srp->BitMap = bsa->bsa_SrcBitMap ;
drp->BitMap = bsa->bsa_DestBitMap ;

MyBitMapScale_whoosh(bsa, srp, drp, dfactor, dformat, SF , DF , &bsa_resources , MULTI , LOOK,
	0, 0, 0, 0, 0 ) ;

cleanup:

#ifdef __AROS__

if( srp ){ FreeRastPort( srp ) ; srp = 0 ; }
if( drp ){ FreeRastPort( drp ) ; drp = 0 ; }

#else

if( srp ){ FreeVec( srp ) ; srp = 0 ; }
if( drp ){ FreeVec( drp ) ; drp = 0 ; }

#endif

bsa_resources_free( &bsa_resources ) ;
}


struct bsa_resources
	{
	uu char *sr , *dr ;
	uu int sr_size , dr_size ;
	uu int *look ; 
	uu int look_size ;
	} ;

void bsa_resources_free( void **bsa_resources )
{
struct bsa_resources *r ;

if( bsa_resources==0 )return ;

r = *bsa_resources ;

if( r==0 )return ;

if( r->sr ){ FreeVec( r->sr ) ; r->sr = 0 ; r->sr_size = 0 ; }
if( r->dr ){ FreeVec( r->dr ) ; r->dr = 0 ; r->dr_size = 0 ; }
if( r->look ){ FreeVec( r->look ) ; r->look = 0 ; r->look_size = 0 ; }

FreeVec( r ) ;

*bsa_resources = 0 ;
}

/* variable naming conventions: x,y are source coords, X,Y dest coords, xx, XX are component pos */
void MyBitMapScale_whoosh(struct BitScaleArgs * bsa , struct RastPort *srp , 
	struct RastPort *drp , int cyberfactor , int cyberformat , int sf , int df ,
	void **bsa_resources , int multi , int looker, int rwidth, int rheight, uu char *rarray,
	unsigned int *sums, char *psums_valid )
{
int xs  = bsa->bsa_SrcX ;	int xsf = bsa->bsa_XSrcFactor ;
int xd  = bsa->bsa_DestX ;	int xdf = bsa->bsa_XDestFactor ;

int ys  = bsa->bsa_SrcY ;	int ysf = bsa->bsa_YSrcFactor ;
int yd  = bsa->bsa_DestY ;	int ydf = bsa->bsa_YDestFactor ;

int offset0 = (ys*rwidth + xs)*cyberfactor ;

uu int sw = bsa->bsa_SrcWidth ;
uu int sh = bsa->bsa_SrcHeight ;
uu int dw = bsa->bsa_DestWidth  = whoosh_ScalerDiv( sw, xdf, xsf ) ;
uu int dh = bsa->bsa_DestHeight = whoosh_ScalerDiv( sh, ydf, ysf ) ;

uu int XQ = xdf / xsf ; uu int XR = xdf % xsf ; 
uu int xq = xsf / xdf ; uu int xr = xsf % xdf ; 
uu int YQ = ydf / ysf ; uu int YR = ydf % ysf ; 
uu int yq = ysf / ydf ; uu int yr = ysf % ydf ;

uu int srmod , srsize ;
uu int drmod , drsize ;

uu int rarray_mod = rwidth * cyberfactor, rarray_mod2 = 2 * rarray_mod ;

uu char *sr = 0 , *dr = 0 ;

struct bsa_resources *r = *bsa_resources ;

int pixel = 0 ;

if( srp==0 || drp==0 )return ;

/* Blit if x-factor == y-factor == 1 */
if( sw==dw && sh == dh )
	{
	/* BltBitMap(sbm,sx,sy,dbm,dx,dy,sizex,sizey,minterm,mask [,tempA]) */
	/* BltBitMap( bsa->bsa_SrcBitMap , xs , ys , bsa->DestBitMap , xd , yd , sw , sh ,
			192 , 255 , 0 ) ; */
	ClipBlit( srp , xs, ys , drp , xd , yd , sw , sh , 0xc0 ) ;
	return ;	
	}
else if( sw==dw ) /* x-factor==1 , blit rows */
	{
	if( ysf >= ydf ) /* y-reduction */
		{
		uu int h = 0 , y = 0 , Y = 0 ;
		for( Y = 0 ; Y < dh ; Y++ )
			{
			ClipBlit( srp , xs , ys + y , drp , xd , yd + Y , sw , 1 , 0xc0 ) ;
			y+= yq ; h += yr ; 
			if( h >= ydf ){ y++ ; h-= ydf ; }
			}
		return ;
		}
	else /* ysf < ydf : y-enlargement */
		{
		uu int y = 0 , Y = 0 , Y1 = 0 , H = 0 ;
		for( y = 0 ; y < sh ; y++ )
			{
			Y1 += YQ ; H += YR ;
			if( H >= ysf ){ H -= ysf ; Y1++ ; }
			if( Y1 > dh )Y1 = dh ;
			for( ; Y < Y1  ; Y ++ )ClipBlit(srp, xs, ys+y, drp, xd, yd+Y, sw, 1, 0xc0) ;
			}
		return ;
		}
	}
else if( sh==dh ) /* y-factor==1, blit columns */
	{
	if( xsf >= xdf ) /* x-reduction */
		{
		uu int x=0 , w=0 , X ;
		for( X = 0 ; X < dw ; X++ )
			{
			ClipBlit( srp , xs+x , ys , drp , xd+X, yd , 1 , sh , 0xc0 ) ;
			x += xq ; w += xr ; if( w >= xdf ){ w -= xdf ; x++ ; }
			}
		return ;
		}
	else  /* xsf < xdf, x-enlargement */
		{
		uu int x=0, X=0, X1=0, W=0 ;
		for( x = 0 ; x < sw ; x++ )
			{
			X1 += XQ ; W += XR ;
			if( W >= xsf ){ W -= xsf ; X1++ ; }
			if( X1 > dw )X1 = dw ;
			for( ; X < X1 ; X++)ClipBlit( srp, xs+x , ys, drp, xd+X, yd, 1, sh, 0xc0 ) ;
			}
		return ;
		}
	}


/*
pixel based source if reduction and x-factor==xdf/xsf <= df/sf , ie xdf * sf <= xsf * df ,
*/
if( looker && xsf >= xdf && xdf * sf <= xsf * df )
	{ pixel=1 ; cyberfactor = 4 ; cyberformat = RECTFMT_RGBA ; }
else pixel = 0 ;

srmod = cyberfactor * sw ; 
drmod = cyberfactor * dw ;

if( r==0 )
	{
	r = *bsa_resources = AllocVec( sizeof( struct bsa_resources ) , MEMF_CLEAR ) ;
	}

if( ysf >= ydf ) /* y-reduction */
	{ 
	drsize = drmod * multi ;
	/* pre20060611: srsize = srmod ; */
	/* 20060611: */
	if( cyberfactor==3 )srsize = srmod * (yq+1) ;
	else srsize = srmod ;
	}
else		/* y-enlargement */
	{
	srsize = srmod * multi ;
	drsize = drmod ;
	}

if( pixel==0 && 0==rescale_realloc_line(  &r->sr , &r->sr_size , srsize ) )return ;
sr = r->sr ;

if( 0==rescale_realloc_line(  &r->dr , &r->dr_size , drsize ) )return ;
dr = r->dr ;

/* compute lookup: */
if( looker && xsf >= xdf ) /* x-reduction */
	{
	if(0==rescale_realloc_line((void *)(&r->look), &r->look_size, sizeof(int)*dw))return ;
	
	switch( cyberfactor )
		{
		case 1 : case 2 : case 4 :
		{
		uu int x = 0 , w = 0 , X = 0 ;
		for( X = 0 ; X < dw ; X++ )
			{
			r->look[ X ] = x ;
			x += xq ; w += xr ; if( w >= xdf ){ w -= xdf ; x++ ; }
			}
		}
		break ;
		
		default: /* pixel==0 as cyberfactor is 4 for pixel==1 */
		{
		uu int x = 0 , w = 0 , X = 0 ;
		for( X = 0 ; X < dw ; X++ )
			{
			r->look[ X ] = x * cyberfactor ;
			x += xq ; w += xr ; if( w >= xdf ){ w -= xdf ; x++ ; }
			}
		}		
		break ;
		}
	
	}
else if( looker )	/* x-enlargement */
	{
	uu int X = 0 , X1 = 0 , W = 0 , x ;
	if(0==rescale_realloc_line((void *)(&r->look), &r->look_size, sizeof(int)*sw))return ;
	
	for( x = 0 ; x < sw ; x++ )
		{
		X1 += XQ ; W += XR ; if( W >= xsf ){ W -= xsf ; X1++ ; }
		if( X1 > dw )X1 = dw ;
		r->look[ x ] = X1 ;
		}
	}

if( ysf >= ydf && sums && rarray && xsf >= xdf && looker==0 && pixel==0 && multi==1 )
		/* y-reduction => multi-write dr */
	{
	uu int h = 0 , y, y_new, Y ;
	
	if( (*psums_valid)==0 )
		{
		sums_compute( sums, rarray, rwidth, rheight ) ;
		(*psums_valid)=1 ;
		}
	
	for( Y = 0, y = ys ; Y < dh ; Y++ ) /* scan dest vertically */
		{
		y_new = y + yq ; 
		h += yr ;
		if( h >= ydf ){ y_new++ ; h -= ydf ; }
		
		/*
		reduction_sums( dr0 , dw , sr , xq , xr , xsf , xdf , cyberfactor ) ;
		*/

		reduction_sums(dr, dw, sums, xs, y, y_new, rwidth, xq, xr, xdf );
		y = y_new ;
		
		/*WritePixelArray(srcRect,SrcX,SrcY,SrcMod,rp,dstX,dstY,SizeX,SizeY,scFmt)*/
		WritePixelArray(dr, 0, 0, drmod, drp, xd, yd+Y, dw, multi, cyberformat);
		}
	}
else if( ysf >= ydf ) /* y-reduction => multi-write dr */
	{
	uu int h = 0 , y = 0 , y_new, Y = 0 , offset = 0 , mod = 0 ; uu char *dr0 ;
	uu int y_rwidth_cyberfactor = 0 ; /* y * rwidth * cyberfactor */
	uu int y_rwidth_cyberfactor_new = 0 ; uu int rwidth_cyberfactor = rwidth * cyberfactor ;
	uu int yq_rwidth_cyberfactor = yq * rwidth * cyberfactor ;
	
	for( Y = 0 ; Y < dh ; ) /* scan dest vertically */
		{
		dr0 = &dr[ offset ] ; 
		
			{
			/* 20060611 */
			y_new = y + yq ; 
			y_rwidth_cyberfactor_new = y_rwidth_cyberfactor + yq_rwidth_cyberfactor ;
			h += yr ; 
			if( h >= ydf )
				{ 
				y_new++ ; y_rwidth_cyberfactor_new += rwidth_cyberfactor ;
				h -= ydf ; 
				}
			/* I dont know if at last point there could be an overflow??? */
			}
		
		/*ReadPixelArray(dstRect,dstX,dstY,destMod,rp,srcX,SrcY,SizeX,SizeY,DestFormat)*/
		if( pixel==0 )
			{
			/*
			pre20060611 was just:
			ReadPixelArray(sr,0,0,srmod, srp, xs, ys+y, sw, 1, cyberformat) ;
			*/
			/* 20060611: */
			if( cyberfactor==3 && rarray==0 )
				{
				uu int i0, i1, total, into, y_diff = y_new - y ; 
				ReadPixelArray(sr,0,0,srmod,srp,xs, ys+y, sw, y_diff, cyberformat);
				/* :pre 20060611 1 replaced by y_diff         ^^^^^^  <= yq+1*/
				/* 20060611: replace top row by average */
				for( i0 = 0 ; i0 < srmod ; i0++ ) /* scan x */
					{
					total = 0 ; into = 0 ;
					for( i1 = 0 ; i1 < y_diff ; i1++ )
						{
						total += sr[ i0 + into ] ;
						into += srmod ; /* to next row */
						} 
					sr[ i0 ] = total / y_diff ;
					}
				}
			else if( cyberfactor==3 && rarray )
				{
				uu int i0, i1, total, into, into0, y_diff = y_new - y ; 
				
				/*                     srcx srcy sizex sizey              */
		/*	ReadPixelArray(sr,0,0,srmod,srp,xs, ys+y, sw, y_diff, cyberformat);*/
			/* :pre 20060611 1 replaced by y_diff         ^^^^^^  <= yq+1*/
				/* 20060611: replace top row by average */
				into0 = offset0 + y_rwidth_cyberfactor ;  
				
	if( y_diff==1 )
		{
		for( i0 = 0 ; i0 < srmod ; i0++ )sr[ i0 ] = rarray[ i0 + into0 ] ;
		}
	else if( y_diff==2 )
		{
		uu int into1 = into0 + rarray_mod ;
		for( i0 = 0 ; i0 < srmod ; i0++ )
			{
			sr[ i0 ] = (rarray[ i0 + into0] + rarray[ i0 + into1])>>1 ;
			}
		}
	else if( y_diff==3 )
		{
		uu int into1 = into0 + rarray_mod, into2 = into1 + rarray_mod ;
		for( i0 = 0 ; i0 < srmod ; i0++ )
			{
			sr[ i0 ] = 
				(rarray[ i0 + into0] + rarray[ i0 + into1] + rarray[ i0 + into2])/3;
			}
		}
	else if( y_diff==4 )
		{
		uu int into1 = into0 + rarray_mod, into2 = into1 + rarray_mod, 
			into3 = into2 + rarray_mod ;
		for( i0 = 0 ; i0 < srmod ; i0++ )
			{
			sr[ i0 ] = 
				(rarray[ i0 + into0] + rarray[ i0 + into1] 
					+ rarray[ i0 + into2] + rarray[ i0 + into3 ]) >> 2;
			}
		}
	else
		{
		/* above are all optimisations of this case: */				
		for( i0 = 0 ; i0 < srmod ; i0++ )
			{
			/* int num = 0 ; */
			total = 0 ; into = i0+into0 ;
			for( i1 = 0 ; i1 < y_diff ; i1++ )
				{
				total += rarray[ into ] ;
				/* num ++ ; */
				into += rarray_mod ;
				} 
			sr[ i0 ] = total / y_diff ;
			}
		}
				}
			else ReadPixelArray(sr,0,0,srmod, srp, xs, ys+y, sw, 1, cyberformat) ;
			}
		if( xsf >= xdf )
			{
			if( looker )
				{
				if( pixel )reduction_p(dr0,dw,srp,xs,ys+y,r->look);
				else reduction_look( dr0 , dw,sr,cyberfactor,r->look);
				}
			else reduction( dr0 , dw , sr , xq , xr , xsf , xdf , cyberfactor ) ;
			}
		else 
			{
			if( looker )enlargement_look( dr0 , sw, sr, cyberfactor, r->look ) ;
			else
				{
				enlargement( dr0, dw, sw, sr, XQ, XR, xsf, xdf, cyberfactor ) ;
				}
			}
		
		y = y_new ; y_rwidth_cyberfactor = y_rwidth_cyberfactor_new ; /* :20060611 */
		
		/* pre 20060611: y += yq ; h += yr ; if( h >= ydf ){ y++ ; h -= ydf ; } */
		
		offset += drmod ; mod++ ; Y++ ;
		if( mod==multi )
			{/* multi==4, just done 0,1,2,3 mod==4==Y */
			/*WritePixelArray(srcRect,SrcX,SrcY,SrcMod,rp,dstX,dstY,SizeX,SizeY,scFmt)*/
			WritePixelArray(dr, 0, 0, drmod, drp, xd, yd+Y-mod,dw, multi, cyberformat);
			mod=offset=0;
			}
		}
	if( mod )WritePixelArray(dr, 0, 0, drmod, drp, xd, yd+Y-mod, dw, mod, cyberformat) ;
	}
else	/* y-enlargement , multi-read sr */
	{
	uu int H = 0 , y = 0 , Y = 0 , Y1 = 0 , mod = 0 , toread , offset = 0 ; uu char *sr0 ;
	for( y = 0 ; y < sh ; y++ ) /* scan source vertically */
		{
		/*ReadPixelArray(dstRect,dstX,dstY,destMod,rp,srcX,SrcY,SizeX,SizeY,DestFormat)*/
		if( mod==0 && pixel==0 )
			{
			if( y + multi <= sh )toread = multi ;
			else toread = sh - y ;
			ReadPixelArray(sr,0,0,srmod,srp,xs,ys+y,sw,toread,cyberformat);
			}
		if( pixel==0 )sr0 = &sr[ offset ] ;
		if( xsf >= xdf )
			{
			if( looker )
				{
				if( pixel )reduction_p(dr,dw,srp,xs,ys+y,r->look);
				else reduction_look(dr, dw, sr0, cyberfactor, r->look) ;
				}
			else reduction( dr , dw , sr0 , xq , xr , xsf , xdf , cyberfactor ) ;
			}
		else 
			{
			if( looker )enlargement_look( dr, sw, sr0, cyberfactor, r->look ) ;
			else enlargement( dr, dw, sw, sr0, XQ, XR, xsf, xdf, cyberfactor ) ;
			}
		
		Y1 += YQ ; H += YR ; if( H >= ysf ){ Y1++ ; H -= ysf ; }
		if( Y1 > dh )Y1 = dh ;
		
		for( ; Y < Y1 ; Y++ )
			{
			/*WritePixelArray(srcRect,SrcX,SrcY,SrcMod,rp,dstX,dstY,SizeX,SizeY,scFmt)*/
			WritePixelArray( dr, 0, 0, drmod, drp, xd, yd + Y, dw, 1, cyberformat ) ;
			}
		
		if( pixel==0 )
			{
			mod++ ; offset += srmod ; 
			if( mod==multi ){ offset = mod = 0 ; }
			}
		}
	}
}

/*
#include "rescale.c" 
*/

static void enlargement( uu char *dr , 
		uu int dw , 
		uu int sw , 
		uu char *sr ,
		uu int XQ , 
		uu int XR , 
		uu int xsf , 
		uu int xdf , 
		int cyberfactor )
{
uu short *dr2 = (void *)dr ;
uu int   *dr4 = (void *)dr ;
uu short *sr2 = (void *)sr ;
uu int   *sr4 = (void *)sr ;

#define		enlarge(dr0, sr0, XQ0, XR0, xsf0, dw0)	\
	{						\
	uu int x = 0 , X = 0 , i = 0 , W = 0 , c ;	\
							\
	while( 1 )					\
		{					\
		X += XQ0 ; W += XR0 ;			\
		if( W >= xsf0 ){ X++ ; W -= xsf0 ; }	\
		c = sr0[ x++ ] ;			\
		if( X > dw0 )break ;			\
		while( i < X )dr0[ i++ ] = c ;		\
		}					\
	while( i < dw0 )dr0[ i++ ] = c ;		\
	}

switch( cyberfactor )
	{
	case 1 : enlarge( dr, sr, XQ, XR, xsf, dw ) ; break ;
	case 2 : enlarge( dr2, sr2, XQ, XR, xsf, dw ) ; break ;
	case 4 : enlarge( dr4, sr4, XQ, XR, xsf, dw ) ; break ;
	default:
		{
		uu int x = 0 , X = 0 , xx = 0 , XX = 0 , i = 0 , j , W = 0 ;
		for( ; x < sw - 1 ; xx += cyberfactor , x++ )
			{
			X += XQ ; W += XR ;
			if( W >= xsf ){ X++ ; W -= xsf ; }
			
			/* reusing xx repeatedly so dont do xx++ */
			for( ; i < X ; i++ )
				{
				for( j = 0 ; j < cyberfactor ; j++ )dr[ XX++ ] = sr[ xx + j ] ;
				}
			}
	
		/* x==sw -1 : */
		for( ; i < dw ; i++ )
			{
			for( j = 0 ; j < cyberfactor ; j++ )dr[ XX++ ] = sr[ xx + j ] ;
			}
		}
	break ;
	}
}


 void reduction_p( 
		uu char *dr , 
		uu int   dw , 
 	struct RastPort *srp ,
		uu int   xs ,
		uu int   ys , 
		uu int  *look )
{
uu int   *dr4 = (void *)dr ;
uu int X ;

for( X = 0 ; X < dw ; X++ )
	{
	uu int c = ReadRGBPixel( srp , xs + look[ X ] , ys ) ;/* AARRGGBB */
	dr4[ X ] = (c<<8) + ((c>>24) & 0xff) ;
	}
}

static void sums_compute( uu int *sums, uu char *rarray, uu int rwidth, uu int rheight )
{
int x, y ; uu int total0 = 0, total1 = 0, total2 = 0 ;
uu int offset, offset_sums, offset_row ;

offset = 0 ; 
offset_sums = (1+rwidth)*3 + 3 ;
offset_row = (1+rwidth)*3 ;

for( y = 0 ; y < rheight ; y++ )
	{
	for( x = 0 ; x < rwidth ; x++ )
		{
#define formula( xyz, uvw )								\
		sums[ (xyz) ] = sums[ (xyz)-offset_row ] - sums[(xyz)-offset_row-3]	\
			+ sums[ (xyz)-3 ] + rarray[ (uvw) ] ;
		
		formula( offset_sums    , offset     )  
		formula( offset_sums + 1, offset + 1 )
		formula( offset_sums + 2, offset + 2 )
#undef formula
		offset_sums += 3 ; offset += 3 ;
		}
	offset_sums += 3 ;
	}
}

static void reduction_sums( 
		uu char *dr , 
		uu int   dw , 
		uu int *sums,
	        uu int xs,
		uu int y,
		uu int y_new,
		uu int rwidth,
		uu int   xq , 
		uu int   xr , 
		uu int   xdf 
		)
{
/*
uu int X = 0 , w = 0, x, x_new ;

for( X = 0, x = xs ; X < dw ; X++ )
	{
	x_new = x + xq ;
	w += xr ;
	if( w >= xdf ){ x_new ++ ; w -= xdf ; }
	
	dr[ next3 ] from calculation: average of [](x,y),(x_new,y_new)()
	
	x = x_new ;
	}
*/
uu int w = 0, y_diff = y_new-y ;
uu int offset0 = (y * (rwidth+1) + xs) * 3,
	offset1 = ( y_new * (rwidth+1) + xs) * 3,
	offsetq = xq * 3 ;
uu int area, area0 = y_diff * xq, area1 = area0 + y_diff, F0, F1, F2, 
	F0_prev, F1_prev, F2_prev ;
int i, I = 3 * dw ;

F0_prev = sums[ offset1     ] - sums[ offset0     ] ;
F1_prev = sums[ offset1 + 1 ] - sums[ offset0 + 1 ] ;
F2_prev = sums[ offset1 + 2 ] - sums[ offset0 + 2 ] ;

for( i = 0 ; i < I ;  )
	{
	/* x_new = x + xq ; */
	offset1 += offsetq ;
	offset0 += offsetq ;
	
	w += xr ;
	
	if( w >= xdf ){ /* x_new ++ */ offset1 += 3 ; offset0 += 3 ; w -= xdf ; area = area1 ; }
	else area = area0 ;
	
	F0 = sums[ offset1     ] - sums[ offset0     ] ;
	F1 = sums[ offset1 + 1 ] - sums[ offset0 + 1 ] ;
	F2 = sums[ offset1 + 2 ] - sums[ offset0 + 2 ] ;
		
	dr[ i     ] = (F0 - F0_prev) / area ;
	dr[ i + 1 ] = (F1 - F1_prev) / area ;
	dr[ i + 2 ] = (F2 - F2_prev) / area ;
		
	i += 3 ;
	F0_prev = F0 ; F1_prev = F1 ; F2_prev = F2 ;
	}
}







static void reduction( 
		uu char *dr , 
		uu int   dw , 
		uu char *sr , 
		uu int   xq , 
		uu int   xr , 
		uu int   xsf ,
		uu int   xdf , 
		int      cyberfactor )
{
uu short *dr2 = (void *)dr ;
uu int   *dr4 = (void *)dr ;
uu short *sr2 = (void *)sr ;
uu int   *sr4 = (void *)sr ;
int cyberfactor2 = 2 * cyberfactor ;
int cyberfactor3 = 3 * cyberfactor ;
int cyberfactor4 = 4 * cyberfactor ;

#define reduction_( DR , SR )				\
	{						\
	uu int X , x , w ;				\
	for( X = x = w = 0 ; X < dw ; )			\
		{					\
		DR[ X++ ] = SR[ x ] ;			\
		x += xq ; w += xr ;			\
		if( w >= xdf ){ x++ ; w -= xdf ; } 	\
		}					\
	}

switch( cyberfactor )
	{
	case 1 : reduction_( dr , sr ) ; break ;
	case 2 : reduction_( dr2 , sr2 ) ; break ;
	case 4 : reduction_( dr4 , sr4 ) ; break ;
	default:
		{
		uu int C = 0 , c = 0 , X = 0 , w = 0 , i , delta = cyberfactor * xq ;
		for( ; X < dw ; X++ )
			{
			uu int c_new = 0 ;
			/* pre anti-alias version: ie pre 20060611 
			for( i = 0 ; i < cyberfactor ; i++ )dr[ C++ ] = sr[ c+i ] ;
			
			c += delta ; w += xr ;
			if( w >= xdf ){ c+= cyberfactor ; w -= xdf ; }
			*/
			
			/* new anti-alias version: */
			
			c_new = c + delta ; w += xr ;
			
			if( w >= xdf ){ c_new += cyberfactor ; w -= xdf ; }
			
			for( i = 0 ; i < cyberfactor ; i++ )
				{
				
				uu int d = c+i ;
				
				if( c_new==c+cyberfactor )dr[ C++ ] = sr[d] ;
				else if( c_new==c + cyberfactor2 )
					{
					dr[C++]=(sr[d] + sr[d+cyberfactor])>>1;
					}
				else if( c_new==c + cyberfactor3 )
					{
					dr[C++]=(sr[d] + sr[d+cyberfactor]
						+sr[d+cyberfactor2])/3;
					}
				else if( c_new==c + cyberfactor4 )
					{
					dr[C++]=(sr[d] + sr[d+cyberfactor]
						+sr[d+cyberfactor2]+sr[d+cyberfactor3])>>2;
					}
				else
					{
					uu int total ; uu int d0, d_new = c_new+i ; int num = 0 ;
					for( total = 0, d0 = c+i ; d0 < d_new ; d0 += cyberfactor )
						{
						total += sr[ d0 ] ; num++ ;
						} 
					
					dr[ C++ ] = total / num ;
					/* 
					true for all above cases: above are j optzns
					for( total = 0, c0 = c ; c0 < c_new ; c0+= cyberfactor)
						{
						total += sr[ c0 + i ] ; num++ ;
						}
					dr[ C++ ] = total / num ;
					*/
					}
				}
			c = c_new ;
			}
		}
	break ;
	}
}

static int rescale_realloc_line( uu char **pr , uu int *pr_size , uu int wanted_size )
{
if( *pr_size < wanted_size )
	{
	if( *pr ){ FreeVec( *pr ) ; }
	*pr = AllocVec( wanted_size , MEMF_PUBLIC ) ;
	
	if( *pr==0 )
		{
		*pr_size = 0 ; 
		Errmess( "failed to allocate source image line buffer\n" ) ; 
		return(0) ; 
		}
	
	*pr_size = wanted_size ;
	}
return( 1 ) ;
}


int whoosh_ScalerDiv( int srcwidth , int num , int denom )
{
if( num > denom ) /* enlarge */
	{
	return( (srcwidth * num) / denom  ) ;
	}
else  /*  num <= denom  :reduction */
	{
	int dest , destwidth , src = srcwidth - 1 ;
	
	if( srcwidth==0 )return( 0 ) ;
	
	/* src >= 0 */
	dest = (src * num) / denom ;

	while( 1 )
		{
		int s = (dest * denom) / num ;
		if( s > src )dest-- ;
		else break ;
		}
	/* dest * denom / num <= src : when dest hits 0, get s==0 <= src exit */
	while( 1 )
		{
		int s = ((dest + 1)* denom) / num ;
		if( s <= src )dest++ ;
		else break ;
		}
	return( dest + 1 ) ;
	}
}

