
/* Copyright (C) 2004 whoosh777@blueyonder.co.uk  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file whoosh_LICENSE in this distribution.
  
  For more information about licensing, please email 
  whoosh777@blueyonder.co.uk
  For information on commercial licensing, email whoosh777@blueyonder.co.uk

  sometimes I may be away from the internet for several weeks, if I am 
  on the internet then I respond quickly to emails,

  My GS813 homepage http://www.whoosh777.pwp.blueyonder.co.uk
*/

/*
if you want your changes to this file to be maintained by whoosh777@blueyonder.co.uk,

ie as I develop further the viewers that the improvements should propagate 
through, 

then you must email me and I will send the current source + 
allocate you a time slot where my own development is "frozen" + 
I will give you rules to be followed in order for your changes to become 
incorporated.

the rules for this are much stricter than AFPL's rules,
this is because this is work in progress,

note also that such changes then become my private property to 
 use however I wish, you can also do whatever you wish with these changes 
ie they split into 2 copies one belongs to me, one belongs to you,

*/

#include "write8.h"

#include "protos.h"

/* 
#include <proto/cybergraphics.h>
*/
/*
#include <inline/cybergraphics.h>
#include <cybergraphx/cybergraphics.h>
*/
#include "whooshputnum.ch"


void errmess( const char *mess ) ;

/*
static void errmess( char *mess ){ PutStr( mess ) ; Flush( Output() ) ; }
*/
/* widthp and heightp if both zero => echo TxtOScan values! */
int overscan_text( int screenmode , int *widthp , int *heightp )
	{
	struct DimensionInfo *disp ;
	disp = dimension_info( screenmode ) ;
	if( disp==0 )
		{
		if( widthp )*widthp = 640 ;
		if( heightp )*heightp = 200 ;
		return( 0 ) ;
		}
	else
		{
		struct Rectangle *rect ; char *rectname ;

		rect = &( disp->TxtOScan ); rectname = "text_overscan" ;

		if( widthp )*widthp = 1 + rect->MaxX ;
		if( heightp )*heightp = 1 + rect->MaxY ;

/* graphics/gfx.h: */
/* Nominal.== 0 , 0 , 639 , 199 for NTSC Hires, doesnt fill, */
if( widthp==0 && heightp==0 )
	{
errmess( rectname );errmess(".MinX = "); myputnum( rect->MinX ) ; errmess("\n");
errmess( rectname );errmess(".MinY = "); myputnum( rect->MinY ) ; errmess("\n");
errmess( rectname );errmess(".MaxX = "); myputnum( rect->MaxX ) ; errmess("\n");
errmess( rectname );errmess(".MaxY = "); myputnum( rect->MaxY ) ; errmess("\n");
	}	
		dimension_info_free( disp ) ;
		disp = 0 ;
		return( 1 ) ;
		}
	}



/* widthp and heightp if both zero => echo Nominal values! */
int nominal( int screenmode , int *widthp , int *heightp )
	{
	struct DimensionInfo *disp ;
	disp = dimension_info( screenmode ) ;
	if( disp==0 )
		{
		if( widthp )*widthp = 640 ;
		if( heightp )*heightp = 200 ;
		return( 0 ) ;
		}
	else
		{
		struct Rectangle *rect ; char *rectname ;

		rect = &( disp->Nominal ); rectname = "Nominal" ;

		if( widthp )*widthp = 1 + rect->MaxX ;
		if( heightp )*heightp = 1 + rect->MaxY ;

/* graphics/gfx.h: */
/* Nominal.== 0 , 0 , 639 , 199 for NTSC Hires, doesnt fill, */
if( widthp==0 && heightp==0 )
	{
errmess( rectname );errmess(".MinX = "); myputnum( rect->MinX ) ; errmess("\n");
errmess( rectname );errmess(".MinY = "); myputnum( rect->MinY ) ; errmess("\n");
errmess( rectname );errmess(".MaxX = "); myputnum( rect->MaxX ) ; errmess("\n");
errmess( rectname );errmess(".MaxY = "); myputnum( rect->MaxY ) ; errmess("\n");
	}	
		dimension_info_free( disp ) ;
		disp = 0 ;
		return( 1 ) ;
		}
	}



/************* WritePixelLine8 accessory functions ***********/

/* number of bytes for array required by WritePixelLine8
 1 -> 16,  15 -> 16, 16 -> 16, 17 -> 32 ,..., 32 -> 32, 
so rounds up to nearest multiple of 16, clearly 1 byte/pixel
*/
int num_bytes( int width )
{
return	( 
		(  
			(width+15)>>4
		)<<4
	);
}

void array_free( UBYTE *array , int width )
{
if( array==0 )return;
FreeMem( (void *)array , num_bytes( width ) ) ;
}

UBYTE *array_alloc( int width )
{
UBYTE *array;

array = (UBYTE *)AllocMem( num_bytes( width ) ,	 MEMF_CLEAR );

return( array ) ; 
}


struct RastPort *rp_alloc( struct RastPort *rp1 , int width , int cyber ) 
{
struct RastPort *rp2 ;
unsigned int flags ;
/* rp1 = win->RPort ; */

flags = 0 ;

if( cyber )flags |= BMF_MINPLANES ;

rp2 = AllocMem( sizeof( struct RastPort ) , MEMF_CLEAR );
*rp2 = *rp1 ;
rp2->Layer = 0 ;
rp2->BitMap = AllocBitMap( width , 1 , rp1->BitMap->Depth , 
		BMF_CLEAR | flags /*try 0 for flags BMF_MINPLANES */ , 
			rp1->BitMap ) ;
return( rp2 ) ;
}

void rp_free( struct RastPort *rp )
{
if( rp == 0 )return ;
FreeBitMap( rp->BitMap ) ;
FreeMem( rp , sizeof( struct RastPort ) ) ;
}

/********* end of WritePixelLine8 accessory functions ***********/

/*********** super bitmap functions *************/
void super_free( struct BitMap *bm )
{
int i ;
if( bm==0 )return;

errmess( "bitmap: width="); myputnum( bm->BytesPerRow * 8 ) ;
errmess( " , height="); myputnum( bm->Rows ) ;
errmess( " , depth="); myputnum( bm->Depth ) ;

errmess("\n");
/*
printf("bitmap: width=%d , height=%d, depth=%d\n",bm->BytesPerRow * 8  , bm->Rows ,
			 bm->Depth ) ;
*/
for( i = 0 ; i < bm->Depth ; i++ )
	{
	if( bm->Planes[ i ] )
		{
		FreeRaster( bm->Planes[ i ] , bm->BytesPerRow * 8 , bm->Rows ) ;
		}
	bm->Planes[ i ] = 0 ;
	}
FreeMem( bm , sizeof( struct BitMap ) ) ; 
bm = 0 ;
}

struct BitMap *super_alloc( int width , int height , int depth )
{
struct BitMap *bm;
int i ;

bm = AllocMem( sizeof( struct BitMap ) , MEMF_CLEAR ) ;
if( bm==0 )goto error;

InitBitMap( bm , depth , width , height ) ;

for( i = 0 ; i < depth ; i++ )
	{
	int size , j ;
	unsigned char *cp ;
	bm->Planes[ i ] = AllocRaster( width , height ) ;
	if( bm->Planes[ i ] == 0 )
		{
		Errmess("couldnt allocate super bitmap\n");
		goto error ;
		}
	size = bm->Rows * bm->BytesPerRow ;
	cp = bm->Planes[ i ] ;
	for( j = 0 ; j < size ; j++ )
		{
		cp [ j ] = 0 ;
		}
	}

return( bm ) ;

error:

super_free( bm ) ;
return( 0 ) ;
}

/********* screenmode functions **************************/
/*
#include <proto/cybergraphics.h>
*/
/*
#include <cybergraphx/cybergraphics.h>
#include <inline/cybergraphics.h>
*/
#include <libraries/asl.h>
/* #include <clib/asl_protos.h> */

/*
extern struct CyberGfxBase *CyberGfxBase ;
*/


int screenmode_general( int usewb , int low )
{
int screenmode ;

screenmode = 0 ; 

if( usewb )screenmode = screenmode_wb( ) ; 
else screenmode = screenmode_request( low ) ;

/* nominal( screenmode , 0 , 0 ) ; */

return( screenmode ) ;
}

/*
original version:

int screenmode_general( 
		int usewb ,
		int iscyber , 
		int cybercalc , int cyberwidth , int cyberheight ,
		int cyberdepth
		)
{
int screenmode , cyberdone ;

screenmode = 0 ; cyberdone = 0 ;

if( iscyber && cybercalc )
	{
	int actualdepth ;

	screenmode = BestCModeIDTags( 
				CYBRBIDTG_NominalWidth , cyberwidth ,
				CYBRBIDTG_NominalHeight , cyberheight ,
				CYBRBIDTG_Depth , cyberdepth ,
				TAG_DONE ) ;
	
	if( screenmode == INVALID_ID )
		{
		Errmess("cybercalc directly failed, ");
		}
	else 
		{
		actualdepth = GetCyberIDAttr( CYBRIDATTR_DEPTH , screenmode ) ;
		if(cyberdepth != actualdepth )
			{
			PutStr("cybercalc produced wonky depth of ");
			myPutNum( actualdepth ) ; PutStr("\n");
			}
		else cyberdone = 1 ;
		}
	
	if( cyberdone==0 )
		PutStr("will obtain screenmode by "
			"alternative decision procedure as determined by other "
			"env variables\n");
	}

if( cyberdone ) ;
else if( usewb )screenmode = screenmode_wb( ) ; 
else
	{
	screenmode = screenmode_request( ) ;
	if( iscyber )
		{
		int nom_width , nom_height , newscreenmode , done ;
		
		done = 0 ;
		
		nominal( screenmode , &nom_width , &nom_height ) ;
		
		newscreenmode = BestCModeIDTags( 
				CYBRBIDTG_NominalWidth , nom_width ,
				CYBRBIDTG_NominalHeight , nom_height ,
				CYBRBIDTG_Depth , cyberdepth ,
				TAG_DONE ) ;
		if( newscreenmode == INVALID_ID )
			{
			PutStr("cybercalc directly failed, ");
			}
		else 
			{
			int actualdepth ;
			actualdepth = GetCyberIDAttr( CYBRIDATTR_DEPTH , screenmode ) ;
			if(cyberdepth != actualdepth )
				{
				PutStr("obtained wonky depth of ");
				myPutNum( actualdepth ) ; PutStr("\n");
				}
			else screenmode = newscreenmode ;
			}
		}
	}

nominal( screenmode , 0 , 0 ) ;

return( screenmode ) ;
}
*/

/***** get wb screenmode *****/

struct Screen *lockwb(void)
{
return( LockPubScreen( 0 ) ) ;
}

void unlockwb( struct Screen *screen )
{
UnlockPubScreen( 0 , screen ) ;
}

int screenmode_wb( void ) 
{
struct Screen *screen;
int mode ;

screen = LockPubScreen( 0 ) ;

mode = GetVPModeID( &(screen->ViewPort) ) ;

UnlockPubScreen( 0 , screen ) ;

return( mode ) ;
}

/***** screenmode requester *****/

int screenmode_request( int low )
{
int screenmode , success ;
struct ScreenModeRequester *smra ;

/*
screenmode = env_int("whooshscreen" , 0 ) ;
if( screenmode )return( screenmode ) ;
*/

smra = 0 ;

screenmode = screenmode_wb( ) ; /* default is wb screenmode */

smra = (struct ScreenModeRequester *)
	AllocAslRequestTags( ASL_ScreenModeRequest, TAG_DONE ) ;

if( smra==0 )
	{
	/* use wb if requester failed, this is a robust fallback mechanism */
	goto cleanup;
	}

success = AslRequestTags( smra ,
		ASLSM_TitleText , "Select screen, some may fail!",
		ASLSM_MinDepth , low ,
		ASLSM_MaxDepth , 32 ,
		TAG_DONE 
		) ;

if( success==0 )goto cleanup ;

screenmode = smra->sm_DisplayID ;

cleanup:

if( smra ){ FreeAslRequest( smra ) ; smra = 0 ; }

return( screenmode ) ;
}

/****************************************/


void dimension_info_free( struct DimensionInfo *disp )
{
if( disp==0 )return;
FreeMem( disp , sizeof( struct DimensionInfo ) ) ;
}

struct DimensionInfo *dimension_info( int screenmode )
{
int  size , result ;
struct DimensionInfo *disp ;

size = sizeof( struct DimensionInfo ) ;
disp = AllocMem( size , MEMF_CLEAR ) ;
result = GetDisplayInfoData( 0 , (UBYTE *)disp , size , DTAG_DIMS , screenmode ) ;

if( result==0 )
	{
	Errmess("$");
	Myputhex( screenmode ) ;
	Errmess(": unable to read DimensionInfo\n");
	dimension_info_free( disp ) ;
	disp = 0 ;
	}

return( disp ) ;
}

int is_lace(void)
{
int screenmode , result , ret , size ;
struct DisplayInfo *disp ;

size = sizeof( struct DisplayInfo ) ;
screenmode = screenmode_wb() ;
disp = AllocMem( size , 0 ) ;
result = GetDisplayInfoData( 0 , (UBYTE *)disp , sizeof( struct DisplayInfo) ,
			DTAG_DISP , screenmode ) ;
ret = 0 ;
if( result && disp->PropertyFlags & DIPF_IS_LACE )ret = 1 ;
FreeMem( disp , size ) ; disp = 0 ;
return( ret ) ;
}
